/*
 * File:   newmain.c
 * Author: henk
 *
 * Created on July 22, 2018, 9:01 AM
 */
//   Pinning of the PIC12F675
//   VDD          (1)    (8)       GND
//   #mod OD  GP5 (2)    (7) GP0   nc
//   nc       GP4 (3)    (6) GP1   nc
//   nc       GP3 (4)    (5) GP2   nc

#define _XTAL_FREQ 4000000UL    // internal RC oscillator frequency
#include <xc.h>
#pragma config BOREN = OFF, CPD = OFF, FOSC = INTRCIO, MCLRE = OFF, WDTE = OFF, CP = OFF, PWRTE = OFF
#define tx_on GPIO=0b00100000  // GP5 is defined high
#define tx_off GPIO=0          // all pins defined low
void beep(void);
void dit(void);
void dah(void);
void morse(char letter);
void sound(int alarm, int duration);
void silence(int duration2);
void main(void) {
    ANSEL=0x00;         // digital IO
    tx_off ;         // all output low
    TRISIO=0b00001000;  //all are outputs , GP3 set as inputs 
    CMCON=0x07;         //Turn comparators off, enabling pins for I/O 
    tx_on;                     // TX on
    morse ('v');
    morse ('o');
    morse ('s');
    morse ('5');
   // morse ('e');
   // Sound 1 = high/low  2 = telephone  alarm 3 = Emergency  alarm 4 = Machine gunfire
    sound(1,5);         // sound , duration in seconds 
    sound(2,5);
    sound(3,5);
  //  sound(4,5);
    silence(5);         //number of seconds of the silence 
    return;
   
}

void morse(char letter){
    __delay_ms(200);
    if (letter=='a') {dit();dah();}
    if (letter=='b') {dah();dit();dit();dit();}
    if (letter=='c') {dah();dit();dah();dit();}
    if (letter=='d') {dah();dit();dit();}
    if (letter=='e') {dit();}
    if (letter=='f') {dit();dit();dah();dit();}
    if (letter=='g') {dah();dah();dit();}
    if (letter=='h') {dit();dit();dit();dit();}
    if (letter=='i') {dit();dit();}
    if (letter=='j') {dit();dah();dah();dah();}
    if (letter=='k') {dah();dit();dah();}
    if (letter=='l') {dit();dah();dit();dit();}
    if (letter=='m') {dah();dah();}
    if (letter=='n') {dah();dit();}
    if (letter=='o') {dah();dah();dah();}
    if (letter=='p') {dit();dah();dah();dit();}
    if (letter=='q') {dah();dah();dit();dah();}
    if (letter=='r') {dit();dah();dit();}
    if (letter=='s') {dit();dit();dit();}
    if (letter=='t') {dah();}
    if (letter=='u') {dit();dit();dah();}
    if (letter=='v') {dit();dit();dit();dah();}
    if (letter=='w') {dit();dah();dah();}
    if (letter=='x') {dit();dah();dah();dit();}
    if (letter=='y') {dah();dit();dah();dah();}
    if (letter=='z') {dah();dah();dit();dit();}
    if (letter=='1') {dit();dah();dah();dah();dah();}
    if (letter=='2') {dit();dit();dah();dah();dah();}
    if (letter=='3') {dit();dit();dit();dah();dah();}
    if (letter=='4') {dit();dit();dit();dit();dah();}
    if (letter=='5') {dit();dit();dit();dit();dit();}
    if (letter=='6') {dah();dit();dit();dit();dit();}
    if (letter=='7') {dah();dah();dit();dit();dit();}
    if (letter=='8') {dah();dah();dah();dit();dit();}
    if (letter=='9') {dah();dah();dah();dah();dit();}
    if (letter=='0') {dah();dah();dah();dah();dah();}
    __delay_ms(500);
}
void dit(void){
    beep();
    __delay_ms(200);
}
void dah(void){
    beep();
    beep();
    beep();
    __delay_ms(200);
}

void beep(void){
    int counter=0;        
    while (counter!=200){     // 200 times 1kHz block
    tx_off;                   // low  0.5msec
    __delay_us(500);
    tx_on;          // GPIO 5 high 0.5msec
    __delay_us(500); ++counter;}
}

void sound(int alarm, int duration){
    if (alarm==1){   //high/low tone
        while (duration!=0){
            int counter=0;        
            while (counter!=200){     
                 tx_off; __delay_us(500);tx_on; __delay_us(500); 
                 ++counter;     }
            int counter=0;        
            while (counter!=250){     
                 tx_off; __delay_us(400);tx_on; __delay_us(400); 
                 ++counter;}
            --duration;    }
                 } 
    if (alarm==2){   // like a telephone is ringing 
        duration=duration*10;
        while (duration!=0){
            int counter=0;        
            while (counter!=20){     
                 tx_off; __delay_us(600);tx_on; __delay_us(600); 
                 ++counter;     }
            int counter=0;        
            while (counter!=25){     
                 tx_off; __delay_us(400);tx_on; __delay_us(400); 
                 ++counter;}
            --duration;    }
                 }
        if (alarm==3){   // like a telephone is ringing 
        duration=duration*2;
        while (duration!=0){
            int counter=0;        
            while (counter!=20){     
                 tx_off; __delay_us(600);tx_on; __delay_us(600); 
                 ++counter;     }
            int counter=0;        
            while (counter!=25){     
                 tx_off; __delay_us(550);tx_on; __delay_us(550); 
                 ++counter;}
            int counter=0;        
            while (counter!=30){     
                 tx_off; __delay_us(500);tx_on; __delay_us(500); 
                 ++counter;}
            int counter=0;        
            while (counter!=35){     
                 tx_off; __delay_us(450);tx_on; __delay_us(450); 
                 ++counter;}
            int counter=0;        
            while (counter!=40){     
                 tx_off; __delay_us(400);tx_on; __delay_us(400); 
                 ++counter;}
            int counter=0;        
            while (counter!=45){     
                 tx_off; __delay_us(350);tx_on; __delay_us(350); 
                 ++counter;}
            --duration;    }
                 }
    }
void silence(int duration2){
    tx_off;                  // tx off 
    while (duration2!=0){
    __delay_ms(1000) ;       //Time this silence lasts   
    --duration2;}
    tx_on;                   //TX on    
}
